Support unversioned data directory (i.e. data shared between versions)

Bug #1559248 reported by Kyle Fazzari on 2016-03-18
12
This bug affects 2 people
Affects Status Importance Assigned to Milestone
Snappy
High
Kyle Fazzari
snap-confine
Undecided
Kyle Fazzari

Bug Description

Updating a snap from version 1 to version 2 involves copying all of version 1's data into version 2's data directory. This works great for rollbacks etc. but it doesn't scale well for projects with a vast amount of data, e.g. ownCloud (my personal ownCloud data directory is on the order of hundreds of GBs).

Snappy should add support for unversioned data directories that are shared between versions rather than copied. This can be used to great effect in conjunction with the versioned data directories (e.g. database can be versioned, but raw data unversioned, etc.)

Related branches

Didier Roche (didrocks) on 2016-03-21
Changed in snappy:
assignee: nobody → Didier Roche (didrocks)
Michael Vogt (mvo) on 2016-04-20
Changed in snappy:
status: New → Triaged
importance: Undecided → High
Kyle Fazzari (kyrofa) wrote :

Adding ubuntu-core-launcher as it'll need to create the `$HOME/snap/<snap name>/common` directory like it does for `SNAP_USER_DATA`.

Didier Roche (didrocks) wrote :

As we have <snap_data_name_path>/{current, $versions}, I wonder if having /unversioned (as opposed to the $version next to it) would make more sense to developers when looking at their systems. WDYT?

Kyle Fazzari (kyrofa) wrote :

Hey didrocks! Both "shared" and "unversioned" were suggested, but the quorum was reached on "common."

Didier Roche (didrocks) wrote :

Hey Kyle!
who is the quorum? Can that we revisited? I can totally see a lot of developers being puzzled by this.

Kyle Fazzari (kyrofa) wrote :

This is a nasty link, but I think it'll get you to the right conversation: https://github.com/ubuntu-core/snappy/pull/1095/files/ea79104a5d4c1df2407d62bdf060fe992336cd39#diff-a34e166c5b3016c122430c5884f41e9bR236 . The Snappy team decided on "common" there. It's been merged, but not released just yet. Feel free to discuss it with them!

Kyle Fazzari (kyrofa) on 2016-05-03
Changed in snappy:
assignee: Didier Roche (didrocks) → Kyle Fazzari (kyrofa)
Changed in ubuntu-core-launcher:
assignee: nobody → Kyle Fazzari (kyrofa)
Changed in snappy:
status: Triaged → Fix Committed
Zygmunt Krynicki (zyga) wrote :

18:00 < zyga> kyrofa: is this still applicable to snap-confine?
https://bugs.launchpad.net/snap-confine/+bug/1559248
18:00 < ubottu> Launchpad bug 1559248 in Snappy Launcher
                "Support unversioned data directory (i.e. data
                shared between versions)" [Undecided,New]
18:00 < kyrofa> zyga, no, that's done in snap run now
18:00 < zyga> kyrofa: cool, let's close the snap-confine task
              then

Changed in snap-confine:
status: New → Invalid
Kyle Fazzari (kyrofa) on 2016-11-29
Changed in snappy:
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers